package org.deken.game.component;

import java.awt.Graphics2D;
import java.awt.Image;
import org.deken.game.input.InputMouseAction;
import org.deken.game.sprites.Sprite;

/**
 * <p>Title: GameDecoratedContainer</p>
 *
 * <p>Description: This is a container that has decorated (images) around
 * it.</p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>@author Gary Deken</p>
 *
 * @version 1.0
 */
public class GDecoratedContainer extends GContainer {
   private Image topImage;
   private Image bottomImage;
   private Image rightImage;
   private Image leftImage;
   private int topRange = 0;
   private int bottomRange = 0;
   private int rightRange = 0;
   private int leftRange = 0;
   private GContainer internalContainer;

   public GDecoratedContainer(int screenWidth, int screenHeight, GContainer gameContainer) {
      super(screenWidth, screenHeight);
      internalContainer = gameContainer;
   }

   public GDecoratedContainer(int screenWidth, int screenHeight, InputMouseAction inputMouseAction, GContainer gameContainer) {
      super(screenWidth, screenHeight, inputMouseAction);
      internalContainer = gameContainer;
   }

//   @Override
   public void update(long elapseTime) {
      throw new UnsupportedOperationException("Not supported yet.");
   }

//   @Override
   public GComponent copy() {
      throw new UnsupportedOperationException("Not supported yet.");
   }

//   @Override
   public void draw(Graphics2D graphics, int xOffset, int yOffset) {
      if (invalid) {
         validate(graphics);
         setLocations();
      }
//    int middle = (int) getYLocation() + topRange;
//
//    graphics.drawImage(getTopImage(), (int) getXLocation(), (int) getYLocation(), null);
//    graphics.drawImage(getLeftImage(), (int) getXLocation(), middle, null);
//    graphics.drawImage(getRightImage(), (int) getXLocation() + rightRange, middle, null);
//    graphics.drawImage(getBottomImage(), (int) getXLocation(), (int) getYLocation() + bottomRange, null);

      internalContainer.draw(graphics, xOffset, yOffset);
   }

   public void notifyListener(InputMouseAction inputMouseAction) {
      throw new UnsupportedOperationException("Not supported yet.");
   }

   @Override
   public void validate(Graphics2D graphics) {
      internalContainer.validate(graphics);
   }

   @Override
   public GComponent getComponentByName(String name) {
      return internalContainer.getComponentByName(name);
   }

   @Override
   public void remove(GComponent gameComponent) {
      internalContainer.remove(gameComponent);
   }

   @Override
   protected void spriteCollison(Sprite collideSprite) {
      // Not used.
   }

//  /**
//   * processMouseEvent
//   *
//   * @param event MouseEvent
//   */
//  protected void processMouseEvent(MouseEvent event) {
//    if (event.getID() == MouseEvent.MOUSE_PRESSED) {
//      grabbed = isInGrabArea(event.getX(), event.getY());
//      xOffSet = event.getX() - xPosition;
//      yOffSet = event.getY() - yPosition;
//    }
//    if (event.getID() == MouseEvent.MOUSE_RELEASED) {
//      grabbed = false;
//      xOffSet = 0;
//      yOffSet = 0;
//    }
//
//  }
   /**
    * isInGrabArea
    *
    * <p>Calculate if the mouse pressed is on the edge images.</p>
    *
    * @param x int
    * @param y int
    * @return boolean
    */
//  private boolean isInGrabArea(int x, int y) {
//    // check if within the container.
//    if (getBounds().contains((double) x, (double) y)) {
//      // check if within the top or bottom images
//      if (y < topRange + (int) getYLocation() || y > bottomRange + (int) getYLocation()) {
//        return true;
//      }
//      // check if within the right or left images
//      else if (x < leftRange + (int) getXLocation() || x > rightRange + (int) getXLocation()) {
//        return true;
//      }
//    }
//    return false;
//  }
//  /**
//   * processMouseMotionEvent
//   *
//   * @param event MouseEvent
//   */
//  protected void processMouseMotionEvent(MouseEvent event) {
//    if (grabbed) {
//      // mouse dragged event.
//      setLocation(event.getX() - xOffSet, event.getY() - yOffSet);
//    }
//    else {
//      // mouse move event
//    }
//  }
//
//  /**
//   * processKeyEvent
//   *
//   * @param event KeyEvent
//   */
//  protected void processKeyEvent(KeyEvent event) {
//    System.out.println("Key Event");
//  }
   /**
    * setTopImage
    *
    * <p>Sets the Image to be displayed at the top of the box.</p>
    *
    * @param topImage Image
    */
//  public void setTopImage(Image topImage) {
//    this.topImage = topImage;
//    calculateRanges();
//  }
   /**
    * setBottomImage
    *
    * <p>Sets the Image to be displayed at the bottom of the box.</p>
    *
    * @param bottomImage Image
    */
//  public void setBottomImage(Image bottomImage) {
//    this.bottomImage = bottomImage;
//    calculateRanges();
//  }
   /**
    * setRightImage
    *
    * <p>Sets the Image to be displayed at the right side of the box.</p>
    *
    * @param rightImage Image
    */
//  public void setRightImage(Image rightImage) {
//    this.rightImage = rightImage;
//    calculateRanges();
//  }
   /**
    * setLeftImage
    *
    * <p>Sets the Image to be displayed at the left side of the box.</p>
    *
    * @param leftImage Image
    */
//  public void setLeftImage(Image leftImage) {
//    this.leftImage = leftImage;
//    calculateRanges();
//  }
   /**
    * getTopImage
    *
    * @return Image
    */
//  public Image getTopImage() {
//    return topImage;
//  }
   /**
    * getBottomImage
    *
    * @return Image
    */
//  public Image getBottomImage() {
//    return bottomImage;
//  }
   /**
    * getRightImage
    *
    * @return Image
    */
//  public Image getRightImage() {
//    return rightImage;
//  }
   /**
    * getLeftImage
    *
    * @return Image
    */
//  public Image getLeftImage() {
//    return leftImage;
//  }
//  public void notifyListener(InputAction inputAction) {
//  }
   /**
    * <p>calculates the inside edges of the images that make up the box
    * edges.</p>
    */
   private void setLocations() {
//    height = 0;
//    width = 0;
//    if (topImage != null) {
//      height = topImage.getHeight(null);
//      width = topImage.getWidth(null);
//      // top range: height of top image
//      topRange = topImage.getHeight(null);
//    }
//    if (leftImage != null) {
//      height += leftImage.getHeight(null);
//      // left range: width of left image
//      leftRange = leftImage.getWidth(null);
//    }
//    if (bottomImage != null) {
//      height += bottomImage.getHeight(null);
//      // bottom range top of bottom image
//      bottomRange = height - bottomImage.getHeight(null);
//    }
//    if (rightImage != null) {
//      // right range: left side of right image
//      rightRange = width - rightImage.getWidth(null);
//    }
//    setWidth(width);
//    setHeight(width);
//    setBounds(getXPosition(), getYPosition(), getWidth(), getHeight());
   }
}
